/*
 * Copyright (C) 2005 - 2007 JasperSoft Corporation.  All rights reserved.
 * http://www.jaspersoft.com.
 *
 * Unless you have purchased a commercial license agreement from JasperSoft,
 * the following license terms apply:
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as published by
 * the Free Software Foundation.
 *
 * This program is distributed WITHOUT ANY WARRANTY; and without the
 * implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see http://www.gnu.org/licenses/gpl.txt
 * or write to:
 *
 * Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330,
 * Boston, MA  USA  02111-1307
 */
package com.jaspersoft.jasperserver.irplugin.gui;
import com.jaspersoft.jasperserver.irplugin.JServer;
import com.jaspersoft.jasperserver.irplugin.RepositoryFolder;
import com.jaspersoft.jasperserver.irplugin.gui.dndobjects.FileObject;
import java.awt.datatransfer.Transferable;
import javax.swing.*;
import javax.swing.tree.*;
/**
 *
 * @author  Administrator
 */
public class ReportElementTransferHandler extends javax.swing.TransferHandler {
    
    /** Creates a new instance of TreeTransfertHandler */
    public ReportElementTransferHandler() {
        super();
    }
    
    public int getSourceActions(JComponent c) 
    {
        
        return COPY_OR_MOVE;
    }
    
    protected Transferable createTransferable(JComponent c) 
    {
        RepositoryFolder rf = getSelectedRepositoryObject(c);
        if (rf != null)
        {
            FileObject fo = new FileObject(rf);
            return new it.businesslogic.ireport.gui.dnd.TransferableObject(fo);
        }
        return new it.businesslogic.ireport.gui.dnd.TransferableObject(c);
    }
    
    protected RepositoryFolder getSelectedRepositoryObject(JComponent c)
    {
        if (c instanceof JTree)
        {
            JTree tree = (JTree)c;
            TreePath path = tree.getLeadSelectionPath();
	    DefaultMutableTreeNode selectedNode = (DefaultMutableTreeNode)path.getLastPathComponent();
            
            if ( selectedNode.getUserObject() instanceof RepositoryFolder )
            {
                RepositoryFolder rf = (RepositoryFolder)selectedNode.getUserObject();
                return rf;
            }
        }
        
        return null;
    }
}
